Option Explicit On 
Option Strict On
Option Compare Binary

Imports System

' <remarks>
'   Stellt den Einsprungspunkt der Anwendung bereit.
' </remarks>
Public Class Main

    ' <summary>
    '   Der Einsprungspunkt der Anwendung.
    ' </summary>
    Public Shared Sub Main()

        ' Iterative Version mit Fakultt.
        Console.WriteLine("Berechnung luft, bitte warten...")
        Dim intStart As Integer = Environment.TickCount
        Console.WriteLine("BiFac: {0}", BinomCoeff.BiFac(12, 6))
        Console.WriteLine("Zeit: {0} ms", Environment.TickCount - intStart)

        ' Verbesserte iterative Version.
        Console.WriteLine("Berechnung luft, bitte warten...")
        intStart = Environment.TickCount
        Console.WriteLine("BinomialCoeff: {0}", BinomCoeff.BinomialCoeff(12, 6))
        Console.WriteLine("Zeit: {0} ms", Environment.TickCount - intStart)

        ' Einfache Rekursion.
        Console.WriteLine("Berechnung luft, bitte warten...")
        intStart = Environment.TickCount
        Console.WriteLine("BiRecursive: {0}", BinomCoeff.BiRecursive(12, 6))
        Console.WriteLine("Zeit: {0} ms", Environment.TickCount - intStart)

        ' Dynamische Programmierung.
        Console.WriteLine("Berechnung luft, bitte warten...")
        intStart = Environment.TickCount
        Console.WriteLine("BiDynprog: {0}", BinomCoeff.BiDynprog(12, 6))
        Console.WriteLine("Zeit: {0} ms", Environment.TickCount - intStart)
    End Sub
End Class